Index: LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/physiq_mod.F90	(revision 2641)
@@ -34,12 +34,172 @@
     USE change_srf_frac_mod
     USE surface_data,     ONLY : type_ocean, ok_veget, ok_snow
-    USE phys_local_var_mod ! Variables internes non sauvegardees de la physique
+#ifdef CPP_Dust
+    USE phytracr_spl_mod, ONLY: phytracr_spl
+#endif
+    USE phys_local_var_mod, ONLY: phys_local_var_init, phys_local_var_end, &
+       ! [Variables internes non sauvegardees de la physique]
+       ! Variables locales pour effectuer les appels en serie
+       t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,tr_seri, &
+       ! Dynamic tendencies (diagnostics)
+       d_t_dyn,d_q_dyn,d_ql_dyn,d_qs_dyn,d_u_dyn,d_v_dyn,d_tr_dyn, &
+       d_q_dyn2d,d_ql_dyn2d,d_qs_dyn2d, &
+       ! Physic tendencies
+       d_t_con,d_q_con,d_u_con,d_v_con, &
+       d_tr, &                              !! to be removed?? (jyg)
+       d_t_wake,d_q_wake, &
+       d_t_lwr,d_t_lw0,d_t_swr,d_t_sw0, &
+       d_t_ajsb,d_q_ajsb, &
+       d_t_ajs,d_q_ajs,d_u_ajs,d_v_ajs, &
+       d_t_ajs_w,d_q_ajs_w, &
+       d_t_ajs_x,d_q_ajs_x, &
+       !
+       d_t_eva,d_q_eva, &
+       d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc, &
+       d_t_lscst,d_q_lscst, &
+       d_t_lscth,d_q_lscth, &
+       plul_st,plul_th, &
+       !
+       d_t_vdf,d_q_vdf,d_u_vdf,d_v_vdf,d_t_diss, &
+       d_t_vdf_w,d_q_vdf_w, &
+       d_t_vdf_x,d_q_vdf_x, &
+       d_ts, &
+       !
+       d_t_oli,d_u_oli,d_v_oli, &
+       d_t_oro,d_u_oro,d_v_oro, &
+       d_t_lif,d_u_lif,d_v_lif, &
+       d_t_ec, &
+       !
+       du_gwd_hines,dv_gwd_hines,d_t_hin, &
+       dv_gwd_rando,dv_gwd_front, &
+       east_gwstress,west_gwstress, &
+       d_q_ch4, &
+       !  Special RRTM
+       ZLWFT0_i,ZSWFT0_i,ZFLDN0,  &
+       ZFLUP0,ZFSDN0,ZFSUP0,      &
+       !
+       topswad_aero,solswad_aero,   &
+       topswai_aero,solswai_aero,   &
+       topswad0_aero,solswad0_aero, &
+       !LW additional
+       toplwad_aero,sollwad_aero,   &
+       toplwai_aero,sollwai_aero,   &
+       toplwad0_aero,sollwad0_aero, &
+       !
+       topsw_aero,solsw_aero,       &
+       topsw0_aero,solsw0_aero,     &
+       topswcf_aero,solswcf_aero,   &
+       tausum_aero,tau3d_aero,      &
+       !
+       !variables CFMIP2/CMIP5
+       topswad_aerop, solswad_aerop,   &
+       topswai_aerop, solswai_aerop,   &
+       topswad0_aerop, solswad0_aerop, &
+       topsw_aerop, topsw0_aerop,      & 
+       solsw_aerop, solsw0_aerop,      &
+       topswcf_aerop, solswcf_aerop,   &
+       !LW diagnostics
+       toplwad_aerop, sollwad_aerop,   &
+       toplwai_aerop, sollwai_aerop,   &
+       toplwad0_aerop, sollwad0_aerop, &
+       !
+       ptstar, pt0, slp, &
+       !
+       bils, &
+       !
+       cldh, cldl,cldm, cldq, cldt,      &
+       JrNt,                             &
+       dthmin, evap, fder, plcl, plfc,   &
+       prw, prlw, prsw,                  &
+       s_lcl, s_pblh, s_pblt, s_therm,   &
+       cdragm, cdragh,                   &
+       zustar, zu10m, zv10m, rh2m, qsat2m, &
+       zq2m, zt2m, weak_inversion, &
+       zt2m_min_mon, zt2m_max_mon,   &         ! pour calcul_divers.h
+       t2m_min_mon, t2m_max_mon,  &            ! pour calcul_divers.h
+       !
+       s_pblh_x, s_pblh_w, &
+       s_lcl_x, s_lcl_w,   &
+       !
+       slab_wfbils, tpot, tpote,               &
+       ue, uq, ve, vq, zxffonte,               &
+       zxfqcalving, zxfluxlat,                 &
+       zxrunofflic,                            &
+       zxtsol, snow_lsc, zxfqfonte, zxqsurf,   &
+       rain_lsc, rain_num,                     &
+       !
+       sens_x, sens_w, &
+       zxfluxlat_x, zxfluxlat_w, &
+       !
+       dtvdf_x, dtvdf_w, &
+       dqvdf_x, dqvdf_w, &
+       pbl_tke_input, &
+       t_therm, q_therm, u_therm, v_therm, &
+       cdragh_x, cdragh_w, &
+       cdragm_x, cdragm_w, &
+       kh, kh_x, kh_w, &
+       !
+       ale_wake, alp_wake, & 
+       wake_h, wake_omg, &
+                       ! tendencies of delta T and delta q:
+       d_deltat_wk, d_deltaq_wk, &         ! due to wakes
+       d_deltat_wk_gw, d_deltaq_wk_gw, &   ! due to wake induced gravity waves
+       d_deltat_vdf, d_deltaq_vdf, &       ! due to vertical diffusion
+       d_deltat_the, d_deltaq_the, &       ! due to thermals
+       d_deltat_ajs_cv, d_deltaq_ajs_cv, & ! due to dry adjustment of (w) before convection
+                       ! tendencies of wake fractional area and wake number per unit area:
+       d_s_wk,  d_dens_wk, &             ! due to wakes
+!!!       d_s_vdf, d_dens_vdf, &            ! due to vertical diffusion
+!!!       d_s_the, d_dens_the, &            ! due to thermals
+       !                                  
+       wbeff, zmax_th, &
+       sens, flwp, fiwp,  &
+       ale_bl_stat,alp_bl_conv,alp_bl_det,  &
+       alp_bl_fluct_m,alp_bl_fluct_tke,  &
+       alp_bl_stat, n2, s2,  &
+       proba_notrig, random_notrig,  &
+       !
+       dnwd, dnwd0,  &
+       upwd, omega,  &
+       epmax_diag,  &
+       ep,  &
+       cldemi,  &
+       cldfra, cldtau, fiwc,  &
+       fl, re, flwc,  &
+       ref_liq, ref_ice, theta,  &
+       ref_liq_pi, ref_ice_pi,  &
+       zphi, zx_rh,  &
+       pmfd, pmfu,  &
+       !
+       t2m, fluxlat,  &
+       fsollw, evap_pot,  &
+       fsolsw, wfbils, wfbilo,  &
+       
+       pmflxr, pmflxs, prfl,  &
+       psfl, fraca, Vprecip,  &
+       zw2,  &
+       
+       fluxu, fluxv,  &
+       fluxt,  &
+
+       uwriteSTD, vwriteSTD, &                !pour calcul_STDlev.h
+       wwriteSTD, phiwriteSTD, &              !pour calcul_STDlev.h
+       qwriteSTD, twriteSTD, rhwriteSTD, &    !pour calcul_STDlev.h
+       
+       wdtrainA, wdtrainM,  &
+       beta_prec,  &
+       rneb,  &
+       zxsnow,snowhgt,qsnow,to_ice,sissnow,runoff,albsol3_lic
+       !
     USE phys_state_var_mod ! Variables sauvegardees de la physique
+#ifdef CPP_Dust
+  USE phys_output_write_spl_mod
+#else
     USE phys_output_var_mod ! Variables pour les ecritures des sorties
+#endif
+
     USE phys_output_write_mod
     USE fonte_neige_mod, ONLY  : fonte_neige_get_vars
     USE phys_output_mod
     USE phys_output_ctrlout_mod
-    USE iophy
     use open_climoz_m, only: open_climoz ! ozone climatology from a file
     use regr_pr_av_m, only: regr_pr_av
@@ -74,4 +234,6 @@
 
     USE paramLMDZ_phy_mod
+
+    USE cmp_seri_mod
 
     !IM stations CFMIP
@@ -378,13 +540,13 @@
     !RC
     ! Variables li\'ees \`a la poche froide (jyg et rr)
-    ! Version diagnostique pour l'instant : pas de r\'etroaction sur
-    ! la convection
-
-    REAL t_wake(klon,klev),q_wake(klon,klev) ! wake pour la convection
+
+    INTEGER,  SAVE               :: iflag_wake_tend  ! wake: if =0, then wake state variables are
+                                                     ! updated within calwake
+    !$OMP THREADPRIVATE(iflag_wake_tend)
+    REAL t_w(klon,klev),q_w(klon,klev) ! temperature and moisture profiles in the wake region
+    REAL t_x(klon,klev),q_x(klon,klev) ! temperature and moisture profiles in the off-wake region
 
     REAL wake_dth(klon,klev)        ! wake : temp pot difference
 
-    REAL wake_d_deltat_gw(klon,klev)! wake : delta T tendency due to
-    ! Gravity Wave (/s)
     REAL wake_omgbdth(klon,klev)    ! Wake : flux of Delta_Theta
     ! transported by LS omega
@@ -395,9 +557,4 @@
     REAL wake_dqKE(klon,klev)       ! Wake : differential moistening
     ! (wake - unpertubed) CONV
-    REAL wake_dtPBL(klon,klev)      ! Wake : differential heating
-    ! (wake - unpertubed) PBL
-    REAL wake_dqPBL(klon,klev)      ! Wake : differential moistening
-    ! (wake - unpertubed) PBL
-    REAL wake_ddeltat(klon,klev),wake_ddeltaq(klon,klev)
     REAL wake_dp_deltomg(klon,klev) ! Wake : gradient vertical de wake_omg
     REAL wake_spread(klon,klev)     ! spreading term in wake_delt
@@ -406,9 +563,4 @@
     !
     INTEGER wake_k(klon)            ! Wake sommet
-    !
-    REAL t_undi(klon,klev)          ! temperature moyenne dans la zone
-    ! non perturbee
-    REAL q_undi(klon,klev)          ! humidite moyenne dans la zone
-    ! non perturbee
     !
     !jyg<
@@ -417,13 +569,9 @@
 
     REAL wake_gfl(klon)             ! Gust Front Length
-    REAL wake_dens(klon)
+!!!    REAL wake_dens(klon)         ! moved to phys_state_var_mod
     !
     !
     REAL dt_dwn(klon,klev)
     REAL dq_dwn(klon,klev)
-    REAL wdt_PBL(klon,klev)
-    REAL udt_PBL(klon,klev)
-    REAL wdq_PBL(klon,klev)
-    REAL udq_PBL(klon,klev)
     REAL M_dwn(klon,klev)
     REAL M_up(klon,klev)
@@ -434,14 +582,8 @@
     LOGICAL,SAVE :: ok_adjwk=.FALSE.
     !$OMP THREADPRIVATE(ok_adjwk) 
+    REAL,SAVE :: oliqmax=999.
+    !$OMP THREADPRIVATE(oliqmax) 
     REAL, SAVE :: alp_offset
     !$OMP THREADPRIVATE(alp_offset)
-
-    ! !!
-    !=================================================================
-    !         PROVISOIRE : DECOUPLAGE PBL/WAKE
-    !         --------------------------------
-    REAL wake_deltat_sav(klon,klev)
-    REAL wake_deltaq_sav(klon,klev)
-    !=================================================================
 
     !
@@ -659,7 +801,18 @@
     ! eva: evaporation de l'eau liquide nuageuse
     ! vdf: couche limite (Vertical DiFfusion)
-
+    !
     ! tendance nulles
     REAL, dimension(klon,klev):: du0, dv0, dt0, dq0, dql0, dqi0
+    REAL, dimension(klon)     :: dsig0, ddens0
+    INTEGER, dimension(klon)  :: wkoccur1
+    !
+    ! Flag pour pouvoir ne pas ajouter les tendances. 
+    ! Par defaut, les tendances doivente etre ajoutees et
+    ! flag_inhib_tend = 0
+    ! flag_inhib_tend > 0 : tendances non ajoutees, avec un nombre 
+    ! croissant de print quand la valeur du flag augmente
+    !!! attention, ce flag doit etre change avec prudence !!!
+    INTEGER :: flag_inhib_tend = 0 !  0 is the default value
+!!    INTEGER :: flag_inhib_tend = 2
 
     !
@@ -750,7 +903,7 @@
     REAL zx_lat(nbp_lon,nbp_lat)
     !
-    INTEGER nid_day_seri, nid_ctesGCM
-    SAVE nid_day_seri, nid_ctesGCM
-    !$OMP THREADPRIVATE(nid_day_seri,nid_ctesGCM)
+    INTEGER nid_ctesGCM
+    SAVE nid_ctesGCM
+    !$OMP THREADPRIVATE(nid_ctesGCM)
     !
     !IM 280405 BEG
@@ -970,5 +1123,4 @@
 
     if (first) then 
-
        !CR:nvelles variables convection/poches froides
 
@@ -1044,6 +1196,9 @@
        CALL getin_p('random_notrig_max',random_notrig_max)
        CALL getin_p('ok_adjwk',ok_adjwk)
+       CALL getin_p('oliqmax',oliqmax)
        CALL getin_p('ratqsp0',ratqsp0)
        CALL getin_p('ratqsdp',ratqsdp)
+       iflag_wake_tend = 0
+       CALL getin_p('iflag_wake_tend',iflag_wake_tend)
     ENDIF
 
@@ -1245,4 +1400,19 @@
              ! 11/09/06 rajout initialisation ALE et ALP du wake et PBL(YU)
              !        print*,'apres ini_wake iflag_cld_th=', iflag_cld_th
+             !
+             ! Initialize tendencies of wake state variables (for some flag values
+             ! they are not computed).
+             d_deltat_wk(:,:) = 0.
+             d_deltaq_wk(:,:) = 0.
+             d_deltat_wk_gw(:,:) = 0.
+             d_deltaq_wk_gw(:,:) = 0.
+             d_deltat_vdf(:,:) = 0.
+             d_deltaq_vdf(:,:) = 0.
+             d_deltat_the(:,:) = 0.
+             d_deltaq_the(:,:) = 0.
+             d_deltat_ajs_cv(:,:) = 0.
+             d_deltaq_ajs_cv(:,:) = 0.
+             d_s_wk(:) = 0.
+             d_dens_wk(:) = 0.
           endif
 
@@ -1381,6 +1551,4 @@
        WRITE(lunout,*)'OK freq_outNMC(3)=',freq_outNMC(3)
 
-       include "ini_histday_seri.h"
-
        CALL ini_paramLMDZ_phy(dtime,nid_ctesGCM)
 
@@ -1537,4 +1705,7 @@
     dql0(:,:)=0.
     dqi0(:,:)=0.
+    dsig0(:) = 0.
+    ddens0(:) = 0.
+    wkoccur1(:)=1
     !
     ! Mettre a zero des variables de sortie (pour securite)
@@ -1630,4 +1801,6 @@
        ENDDO
     ENDDO
+    ! Initialize variables used for diagnostic purpose
+    if (flag_inhib_tend .ne. 0) call init_cmp_seri
     !IM
     IF (ip_ebil_phy.ge.1) THEN 
@@ -1972,13 +2145,4 @@
        ENDIF
        ! !!
-       !=================================================================
-       !         PROVISOIRE : DECOUPLAGE PBL/WAKE
-       !         --------------------------------
-       !
-       !!      wake_deltat_sav(:,:)=wake_deltat(:,:)
-       !!      wake_deltaq_sav(:,:)=wake_deltaq(:,:)
-       !!      wake_deltat(:,:)=0.
-       !!      wake_deltaq(:,:)=0.
-       !=================================================================
        !>jyg+nrlmd
        !
@@ -2055,16 +2219,15 @@
             )
        !
-       !=================================================================
-       !         PROVISOIRE : DECOUPLAGE PBL/WAKE
-       !         --------------------------------
-       !
-       !!      wake_deltat(:,:)=wake_deltat_sav(:,:)
-       !!      wake_deltaq(:,:)=wake_deltaq_sav(:,:)
-       !=================================================================
-       !
        !  Add turbulent diffusion tendency to the wake difference variables
        IF (mod(iflag_pbl_split,2) .NE. 0) THEN
-          wake_deltat(:,:) = wake_deltat(:,:) + (d_t_vdf_w(:,:)-d_t_vdf_x(:,:))
-          wake_deltaq(:,:) = wake_deltaq(:,:) + (d_q_vdf_w(:,:)-d_q_vdf_x(:,:))
+!jyg<
+          d_deltat_vdf(:,:) = d_t_vdf_w(:,:)-d_t_vdf_x(:,:)
+          d_deltaq_vdf(:,:) = d_q_vdf_w(:,:)-d_q_vdf_x(:,:)
+          CALL add_wake_tend &
+             (d_deltat_vdf, d_deltaq_vdf, dsig0, ddens0, wkoccur1, 'vdf', abortphy) 
+       ELSE
+          d_deltat_vdf(:,:) = 0.
+          d_deltaq_vdf(:,:) = 0.
+!>jyg
        ENDIF
 
@@ -2075,9 +2238,9 @@
           CALL add_pbl_tend &
                (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,&
-               'vdf',abortphy)
+               'vdf',abortphy,flag_inhib_tend)
        ELSE
           CALL add_phys_tend &
                (d_u_vdf,d_v_vdf,d_t_vdf+d_t_diss,d_q_vdf,dql0,dqi0,paprs,&
-               'vdf',abortphy)
+               'vdf',abortphy,flag_inhib_tend)
        ENDIF
        !--------------------------------------------------------------------
@@ -2241,24 +2404,24 @@
        !=======================================================================
        !ajout pour la parametrisation des poches froides: calcul de
-       !t_wake et t_undi: si pas de poches froides, t_wake=t_undi=t_seri
-       do k=1,klev
-          do i=1,klon
-             if (iflag_wake>=1) then
-                t_wake(i,k) = t_seri(i,k) &
+       !t_w et t_x: si pas de poches froides, t_w=t_x=t_seri
+       if (iflag_wake>=1) then
+         do k=1,klev
+            do i=1,klon
+                t_w(i,k) = t_seri(i,k) &
                      +(1-wake_s(i))*wake_deltat(i,k)
-                q_wake(i,k) = q_seri(i,k) &
+                q_w(i,k) = q_seri(i,k) &
                      +(1-wake_s(i))*wake_deltaq(i,k)
-                t_undi(i,k) = t_seri(i,k) &
+                t_x(i,k) = t_seri(i,k) &
                      -wake_s(i)*wake_deltat(i,k)
-                q_undi(i,k) = q_seri(i,k) &
+                q_x(i,k) = q_seri(i,k) &
                      -wake_s(i)*wake_deltaq(i,k)
-             else
-                t_wake(i,k) = t_seri(i,k)
-                q_wake(i,k) = q_seri(i,k)
-                t_undi(i,k) = t_seri(i,k)
-                q_undi(i,k) = q_seri(i,k)
-             endif
-          enddo
-       enddo
+            enddo
+         enddo
+       else
+                t_w(:,:) = t_seri(:,:)
+                q_w(:,:) = q_seri(:,:)
+                t_x(:,:) = t_seri(:,:)
+                q_x(:,:) = q_seri(:,:)
+       endif
        !
        !jyg<
@@ -2269,21 +2432,30 @@
           IF (ok_adjwk) THEN
              limbas(:) = 1
-             CALL ajsec(paprs, pplay, t_wake, q_wake, limbas, &
+             CALL ajsec(paprs, pplay, t_w, q_w, limbas, &
                   d_t_adjwk, d_q_adjwk)
-          ENDIF
-          !
-          DO k=1,klev
-             DO i=1,klon
-                IF (wake_s(i) .GT. 1.e-3) THEN
-                   t_wake(i,k) = t_wake(i,k) + d_t_adjwk(i,k)
-                   q_wake(i,k) = q_wake(i,k) + d_q_adjwk(i,k)
-                   wake_deltat(i,k) = wake_deltat(i,k) + d_t_adjwk(i,k)
-                   wake_deltaq(i,k) = wake_deltaq(i,k) + d_q_adjwk(i,k)
-                ENDIF
+             !
+             DO k=1,klev
+                DO i=1,klon
+                   IF (wake_s(i) .GT. 1.e-3) THEN
+                      t_w(i,k) = t_w(i,k) + d_t_adjwk(i,k)
+                      q_w(i,k) = q_w(i,k) + d_q_adjwk(i,k)
+                      d_deltat_ajs_cv(i,k) = d_t_adjwk(i,k)
+                      d_deltaq_ajs_cv(i,k) = d_q_adjwk(i,k)
+                   ELSE
+                      d_deltat_ajs_cv(i,k) = 0.
+                      d_deltaq_ajs_cv(i,k) = 0.
+                   ENDIF
+                ENDDO
              ENDDO
-          ENDDO
+             CALL add_wake_tend &
+                 (d_deltat_ajs_cv, d_deltaq_ajs_cv, dsig0, ddens0, wkoccur1, 'ajs_cv', abortphy) 
+          ENDIF  ! (ok_adjwk)
        ENDIF ! (iflag_wake>=1)
        !>jyg
        !
+        
+!!      print *,'physiq. q_w(1,k), q_x(1,k) ', &
+!!             (k, q_w(1,k), q_x(1,k),k=1,25)
+
 !jyg<
        CALL alpale( debut, itap, dtime, paprs, omega, t_seri,   &
@@ -2324,6 +2496,6 @@
           !c          CALL concvl (iflag_con,iflag_clos,
           CALL concvl (iflag_clos, &
-               dtime, paprs, pplay, k_upper_cv, t_undi,q_undi, &
-               t_wake,q_wake,wake_s, &
+               dtime, paprs, pplay, k_upper_cv, t_x,q_x, &
+               t_w,q_w,wake_s, &
                u_seri,v_seri,tr_seri,nbtr_tmp, &
                ALE,ALP, &
@@ -2342,4 +2514,5 @@
                wdtrainA,wdtrainM,wght_cvfd,qtc_cv,sigt_cv, &
                tau_cld_cv,coefw_cld_cv,epmax_diag)
+
           ! RomP <<<
 
@@ -2457,5 +2630,5 @@
 
     CALL add_phys_tend(d_u_con, d_v_con, d_t_con, d_q_con, dql0, dqi0, paprs, &
-         'convection',abortphy)
+         'convection',abortphy,flag_inhib_tend)
 
     !-------------------------------------------------------------------------
@@ -2540,41 +2713,4 @@
           ENDDO
        ENDDO
-       !nrlmd+jyg<
-       DO k=1,klev
-          DO i=1,klon
-             wdt_PBL(i,k) =  0.
-             wdq_PBL(i,k) =  0.
-             udt_PBL(i,k) =  0.
-             udq_PBL(i,k) =  0.
-          ENDDO
-       ENDDO
-       !
-       IF (mod(iflag_pbl_split,2) .EQ. 1) THEN
-          DO k=1,klev
-             DO i=1,klon
-                wdt_PBL(i,k) = wdt_PBL(i,k) + d_t_vdf_w(i,k)/dtime
-                wdq_PBL(i,k) = wdq_PBL(i,k) + d_q_vdf_w(i,k)/dtime
-                udt_PBL(i,k) = udt_PBL(i,k) + d_t_vdf_x(i,k)/dtime
-                udq_PBL(i,k) = udq_PBL(i,k) + d_q_vdf_x(i,k)/dtime
-                !!        dt_dwn(i,k)  = dt_dwn(i,k) + d_t_vdf_w(i,k)/dtime
-                !!        dq_dwn(i,k)  = dq_dwn(i,k) + d_q_vdf_w(i,k)/dtime
-                !!        dt_a  (i,k)    = dt_a(i,k) + d_t_vdf_x(i,k)/dtime
-                !!        dq_a  (i,k)    = dq_a(i,k) + d_q_vdf_x(i,k)/dtime
-             ENDDO
-          ENDDO
-       ENDIF
-       IF (mod(iflag_pbl_split/2,2) .EQ. 1) THEN
-          DO k=1,klev
-             DO i=1,klon
-                !!        dt_dwn(i,k)  = dt_dwn(i,k) + 0.
-                !!        dq_dwn(i,k)  = dq_dwn(i,k) + 0.
-                !!        dt_a(i,k)   = dt_a(i,k)   + d_t_ajs(i,k)/dtime
-                !!        dq_a(i,k)   = dq_a(i,k)   + d_q_ajs(i,k)/dtime
-                udt_PBL(i,k)   = udt_PBL(i,k)   + d_t_ajs(i,k)/dtime
-                udq_PBL(i,k)   = udq_PBL(i,k)   + d_q_ajs(i,k)/dtime
-             ENDDO
-          ENDDO
-       ENDIF
-       !>nrlmd+jyg
 
        IF (iflag_wake==2) THEN
@@ -2605,31 +2741,34 @@
        !
        !calcul caracteristiques de la poche froide
-       call calWAKE (paprs,pplay,dtime &
-            ,t_seri,q_seri,omega &
-            ,dt_dwn,dq_dwn,M_dwn,M_up &
-            ,dt_a,dq_a,sigd &
-            ,wdt_PBL,wdq_PBL &
-            ,udt_PBL,udq_PBL &
-            ,wake_deltat,wake_deltaq,wake_dth &
-            ,wake_h,wake_s,wake_dens &
-            ,wake_pe,wake_fip,wake_gfl &
-            ,dt_wake,dq_wake &
-            ,wake_k, t_undi,q_undi &
-            ,wake_omgbdth,wake_dp_omgb &
-            ,wake_dtKE,wake_dqKE &
-            ,wake_dtPBL,wake_dqPBL &
-            ,wake_omg,wake_dp_deltomg &
-            ,wake_spread,wake_Cstar,wake_d_deltat_gw &
-            ,wake_ddeltat,wake_ddeltaq)
+       call calWAKE (iflag_wake_tend, paprs, pplay, dtime, &
+            t_seri, q_seri, omega,  &
+            dt_dwn, dq_dwn, M_dwn, M_up,  &
+            dt_a, dq_a,  &
+            sigd,  &
+            wake_deltat, wake_deltaq, wake_s, wake_dens,  &
+            wake_dth, wake_h,  &
+            wake_pe, wake_fip, wake_gfl,  &
+            d_t_wake, d_q_wake,  &
+            wake_k, t_x, q_x,  &
+            wake_omgbdth, wake_dp_omgb,  &
+            wake_dtKE, wake_dqKE,  &
+            wake_omg, wake_dp_deltomg,  &
+            wake_spread, wake_Cstar, d_deltat_wk_gw,  &
+            d_deltat_wk, d_deltaq_wk, d_s_wk, d_dens_wk)
        !
        !-----------------------------------------------------------------------
        ! ajout des tendances des poches froides
-       ! Faire rapidement disparaitre l'ancien dt_wake pour garder un d_t_wake
-       ! coherent avec les autres d_t_...
-       d_t_wake(:,:)=dt_wake(:,:)*dtime
-       d_q_wake(:,:)=dq_wake(:,:)*dtime
        CALL add_phys_tend(du0,dv0,d_t_wake,d_q_wake,dql0,dqi0,paprs,'wake', &
-            abortphy)
+            abortphy,flag_inhib_tend)
        !------------------------------------------------------------------------
+
+!       Increment Wake state variables
+       IF (iflag_wake_tend .GT. 0.) THEN
+
+         CALL add_wake_tend &
+            (d_deltat_wk, d_deltaq_wk, d_s_wk, d_dens_wk, wake_k, &
+             'wake', abortphy) 
+
+       ENDIF   ! (iflag_wake_tend .GT. 0.)
 
     endif  ! (iflag_wake>=1)
@@ -2708,4 +2847,6 @@
                    t_therm(i,k) = t_seri(i,k) - wake_s(i)*wake_deltat(i,k)
                    q_therm(i,k) = q_seri(i,k) - wake_s(i)*wake_deltaq(i,k)
+                   u_therm(i,k) = u_seri(i,k)
+                   v_therm(i,k) = v_seri(i,k)
                 ENDDO
              ENDDO
@@ -2716,4 +2857,6 @@
                    t_therm(i,k) = t_seri(i,k)
                    q_therm(i,k) = q_seri(i,k)
+                   u_therm(i,k) = u_seri(i,k)
+                   v_therm(i,k) = v_seri(i,k)
                 ENDDO
              ENDDO
@@ -2722,7 +2865,6 @@
           call calltherm(pdtphys &
                ,pplay,paprs,pphi,weak_inversion &
-                                ! ,u_seri,v_seri,t_seri,q_seri,zqsat,debut &
-               !jyg
-               ,u_seri,v_seri,t_therm,q_therm,zqsat,debut &  !jyg
+                        ! ,u_seri,v_seri,t_seri,q_seri,zqsat,debut & !jyg
+               ,u_therm,v_therm,t_therm,q_therm,zqsat,debut &  !jyg
                ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs &
                ,fm_therm,entr_therm,detr_therm &
@@ -2751,8 +2893,6 @@
                 DO i=1,klon
                    !
-                   wake_deltat(i,k) = wake_deltat(i,k) - d_t_ajs(i,k)
-                   wake_deltaq(i,k) = wake_deltaq(i,k) - d_q_ajs(i,k)
-                   t_seri(i,k) = t_therm(i,k) + wake_s(i)*wake_deltat(i,k)
-                   q_seri(i,k) = q_therm(i,k) + wake_s(i)*wake_deltaq(i,k)
+                   d_deltat_the(i,k) = - d_t_ajs(i,k) 
+                   d_deltaq_the(i,k) = - d_q_ajs(i,k) 
                    !
                    d_u_ajs(i,k) = d_u_ajs(i,k)*(1.-wake_s(i)) 
@@ -2763,14 +2903,13 @@
                 ENDDO
              ENDDO
-          ELSE
-             DO k=1,klev
-                DO i=1,klon
-                   t_seri(i,k) = t_therm(i,k)
-                   q_seri(i,k) = q_therm(i,k)
-                ENDDO
-             ENDDO
-          ENDIF
-          !>jyg
-!jyg<
+          !
+             CALL add_wake_tend &
+                 (d_deltat_the, d_deltaq_the, dsig0, ddens0, wkoccur1, 'the', abortphy) 
+          !
+          ENDIF  ! (mod(iflag_pbl_split/2,2) .EQ. 1)
+          !
+          CALL add_phys_tend(d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs,  &
+                             dql0,dqi0,paprs,'thermals', abortphy,flag_inhib_tend)
+          !
 !
           CALL alpale_th( dtime, lmax_th, t_seri, cell_area,  &
@@ -2779,4 +2918,5 @@
                           alp_bl, alp_bl_stat, &
                           proba_notrig, random_notrig)
+          !>jyg
 
           ! ------------------------------------------------------------------
@@ -2833,5 +2973,5 @@
           ! ajout des tendances de l'ajustement sec ou des thermiques
           CALL add_phys_tend(du0,dv0,d_t_ajsb,d_q_ajsb,dql0,dqi0,paprs, &
-               'ajsb',abortphy)
+               'ajsb',abortphy,flag_inhib_tend)
           d_t_ajs(:,:)=d_t_ajs(:,:)+d_t_ajsb(:,:)
           d_q_ajs(:,:)=d_q_ajs(:,:)+d_q_ajsb(:,:)
@@ -2892,5 +3032,15 @@
 
     CALL add_phys_tend(du0,dv0,d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc,paprs, &
-         'lsc',abortphy)
+         'lsc',abortphy,flag_inhib_tend)
+    rain_num(:)=0.
+    DO k = 1, klev  ! re-evaporation de l'eau liquide nuageuse
+       DO i = 1, klon
+          IF (ql_seri(i,k)>oliqmax) THEN
+             rain_num(i)=rain_num(i)+(ql_seri(i,k)-oliqmax)*zmasse(i,k)/pdtphys
+             ql_seri(i,k)=oliqmax
+          ENDIF
+       ENDDO
+    ENDDO
+
     !---------------------------------------------------------------------------
     DO k = 1, klev
@@ -2995,118 +3145,4 @@
           enddo
        enddo
-
-       !
-       !jq - introduce the aerosol direct and first indirect radiative forcings
-       !jq - Johannes Quaas, 27/11/2003 (quaas@lmd.jussieu.fr)
-       IF (flag_aerosol .gt. 0) THEN
-          IF (iflag_rrtm .EQ. 0) THEN !--old radiation
-             IF (.NOT. aerosol_couple) THEN
-                !
-                CALL readaerosol_optic( &
-                     debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
-                     pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
-                     mass_solu_aero, mass_solu_aero_pi,  &
-                     tau_aero, piz_aero, cg_aero,  &
-                     tausum_aero, tau3d_aero)
-             ENDIF
-          ELSE                       ! RRTM radiation
-             IF (aerosol_couple .AND. config_inca == 'aero' ) THEN
-                abort_message='config_inca=aero et rrtm=1 impossible'
-                call abort_physic(modname,abort_message,1)
-             ELSE
-                !
-#ifdef CPP_RRTM
-                IF (NSW.EQ.6) THEN
-                   !--new aerosol properties
-                   !
-                   CALL readaerosol_optic_rrtm( debut, aerosol_couple, &
-                        new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
-                        pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
-                        tr_seri, mass_solu_aero, mass_solu_aero_pi,  &
-                        tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,  &
-                        tausum_aero, tau3d_aero)
-
-                ELSE IF (NSW.EQ.2) THEN 
-                   !--for now we use the old aerosol properties
-                   !
-                   CALL readaerosol_optic( &
-                        debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
-                        pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
-                        mass_solu_aero, mass_solu_aero_pi,  &
-                        tau_aero, piz_aero, cg_aero,  &
-                        tausum_aero, tau3d_aero)
-                   !
-                   !--natural aerosols
-                   tau_aero_sw_rrtm(:,:,1,:)=tau_aero(:,:,3,:)
-                   piz_aero_sw_rrtm(:,:,1,:)=piz_aero(:,:,3,:)
-                   cg_aero_sw_rrtm (:,:,1,:)=cg_aero (:,:,3,:)
-                   !--all aerosols
-                   tau_aero_sw_rrtm(:,:,2,:)=tau_aero(:,:,2,:)
-                   piz_aero_sw_rrtm(:,:,2,:)=piz_aero(:,:,2,:)
-                   cg_aero_sw_rrtm (:,:,2,:)=cg_aero (:,:,2,:)
-                ELSE
-                   abort_message='Only NSW=2 or 6 are possible with ' &
-                        // 'aerosols and iflag_rrtm=1'
-                   call abort_physic(modname,abort_message,1)
-                ENDIF
-
-                !--call LW optical properties for tropospheric aerosols 
-                !--only works for INCA aerosol (aerosol_couple = TRUE)
-                CALL aeropt_lw_rrtm(aerosol_couple,paprs,tr_seri)
-                !
-#else
-                abort_message='You should compile with -rrtm if running ' &
-                     // 'with iflag_rrtm=1'
-                call abort_physic(modname,abort_message,1)
-#endif
-                !
-             ENDIF
-          ENDIF
-       ELSE
-          tausum_aero(:,:,:) = 0.
-          IF (iflag_rrtm .EQ. 0) THEN !--old radiation
-             tau_aero(:,:,:,:) = 1.e-15
-             piz_aero(:,:,:,:) = 1.
-             cg_aero(:,:,:,:)  = 0.
-          ELSE
-             tau_aero_sw_rrtm(:,:,:,:) = 1.e-15
-             tau_aero_lw_rrtm(:,:,:,:) = 1.e-15
-             piz_aero_sw_rrtm(:,:,:,:) = 1.0
-             cg_aero_sw_rrtm(:,:,:,:)  = 0.0
-          ENDIF
-       ENDIF
-       !
-       !--STRAT AEROSOL
-       !--updates tausum_aero,tau_aero,piz_aero,cg_aero
-       IF (flag_aerosol_strat.GT.0) THEN
-          IF (prt_level .GE.10) THEN
-             PRINT *,'appel a readaerosolstrat', mth_cur
-          ENDIF
-          IF (iflag_rrtm.EQ.0) THEN
-           IF (flag_aerosol_strat.EQ.1) THEN
-             CALL readaerosolstrato(debut)
-           ELSE
-             abort_message='flag_aerosol_strat must equal 1 for rrtm=0'
-             call abort_physic(modname,abort_message,1)
-           ENDIF
-          ELSE
-#ifdef CPP_RRTM
-            IF (flag_aerosol_strat.EQ.1) THEN
-             CALL readaerosolstrato1_rrtm(debut)
-            ELSEIF (flag_aerosol_strat.EQ.2) THEN
-             CALL stratosphere_mask(t_seri, pplay, latitude_deg)
-             CALL readaerosolstrato2_rrtm(debut)
-            ELSE
-             abort_message='flag_aerosol_strat must equal 1 or 2 for rrtm=1'
-             call abort_physic(modname,abort_message,1)
-            ENDIF
-#else
-             abort_message='You should compile with -rrtm if running ' &
-                  // 'with iflag_rrtm=1'
-             call abort_physic(modname,abort_message,1)
-#endif
-          ENDIF
-       ENDIF
-       !--fin STRAT AEROSOL
 
        !   On prend la somme des fractions nuageuses et des contenus en eau
